#!/usr/bin/perl
#
# Luke's Math Drill Script
# Released into the public domain on February the 16th, 2001
#
# This work is released without copyright.
#
# THIS SOFTWARE IS PROVIDED BY Luke Parrish ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL Luke Parrish BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#
# Description:
# Just a standard math drill program, but it gets harder the more questions 
# you get right, and easier the more you get wrong. You have to get them right 
# within the time limit to count.

print("Press 1 for addition, 2, for multiplication, or 3 for division: ");
$subject=<STDIN>;
chop $subject;
$base=2;
while(true){
$rand1=(rand(10))*($base)%($base+1);
$rand2=(rand(10))*($base)%($base+1);
if(rand(2)<1){$rand1=0-$rand1;}
if(rand(2)<1){$rand2=0-$rand2;}
if($subject==1){
 print("$rand1 \+ $rand2 = ");
}elsif($subject==2){
 print("$rand1 \* $rand2 = ");
}elsif($subject==3){
 $rand2=1+(rand(10)*$base)%$base;
 $rand1=$rand2*((rand(10)*$base)%$base);
 print("$rand1 \/ $rand2 = ");
}
$time=time();
$ans1=<STDIN>;
if($ans1 eq "q\n"){exit;}
if($subject==1){
$ans2=$rand1+$rand2;
}elsif($subject==2){
$ans2=$rand1*$rand2;
}elsif($subject==3){
$ans2=$rand1/$rand2;
}
$taken=time()-$time;
if($ans1==$ans2 && $taken<=5){
$base+=10;
$score=$base-2;
print("Correct! Score $score\n");
}elsif($ans1==$ans2 && $taken>5){
$score=$base-2;
print("Too late! Score $score\n");
}else{
$base-=5;
$score=$base-2;
print("Wrong! Real answer: $ans2, Score $score\n");
}
if($base <= 0){$base=2;}
}
