#!/usr/bin/perl
#
# Memorization Tool 
# Released into the public domain on February the 16th, 2001
#
# This work is released without copyright.          
# 
# THIS SOFTWARE IS PROVIDED BY Luke Parrish ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL Luke Parrish BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Description:
# This program is intended to provide the stimulation for people to memorize 
# passages of text. It's a sort of a game; the higher you score the better 
# you know the text. Perl and a console, such as comes with UNIX, are required.

sub getWords()
{
 $text="a b c d e f g h i j k l m n o p q r s t u v w x y z";
 open(TEXT,"mem.txt");
 read(TEXT,$text,1024*1024);
 close(TEXT);
 $text=~s/<p><i>.*.<\/i>/ /g;
# $text=~s/\r\n\r/ 'paragraph' /g;
# $text=~s/<p>/ 'paragraph' /g;
# $text=~s/<DD>/ 'paragraph' /g;
 $text=~s/<.*?>/ /g;
 $text=~s/\`/'/g;
 $text=~s/[^A-Za-z ,.'";]/ /g;
 @words=split(" ", $text);
}
sub setRand()
{
 $rand=(rand(1000) % 7)+1;
}
sub setWord()
{
 $oddword=@words[$rand+$pos];
 $testword=$oddword;
 $oddword=~s/[^A-Za-z]//g;
 if($oddword eq ""){setRand();setWord();}

}
sub getPrompt()
{
 $answer=<STDIN>;
 if($ans1 eq "q\n"){exit;}
 $answer=~s/[^A-Za-z]//g;
}
sub printWord()
{
 if(length($printed)>50){
  $prev9=$prev8;
  $prev8=$prev7;
  $prev7=$prev6;
  $prev6=$prev5;
  $prev5=$prev4;
  $prev4=$prev3;
  $prev3=$prev2;
  $prev2=$prev1."\n";
  $prev1=$printed;
  $printed="";print $clear;
  print $score."\n\n".$prev9.$prev8.$prev7.$prev6.$prev5.$prev4.$prev3.$prev2.$prev1."\n";
  print $printed=$printed.$word." ";
 setRand();
 setWord();
 }else{
  print $word." ";
  $printed=$printed.$word." ";
 }
}
sub testWord()
{
 if(lc($answer) eq lc($oddword) )
 {
  $right++;
  $total=$right+$wrong;
  $score="$right \- $wrong - Score: $right/$total";
  print $clear;
  print $score."\n\n".$prev9.$prev8.$prev7.$prev6.$prev5.$prev4.$prev3.$prev2.$prev1."\n";
  print $printed;
 }else{
  $wrong++;
  $total=$right+$wrong;
  $score="$right \- $wrong - Score: $right/$total";
  print $clear;
  print $score."\n\n".$prev9.$prev8.$prev7.$prev6.$prev5.$prev4.$prev3.$prev2.$prev1."\n";
#  print $score."\n\n\n";
  print $printed;
 }
 printWord();
 setRand();
 setWord();
}
sub start(){
getWords();
setRand();
setWord();
$clear="\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n";
$pos=0;
$score=$right=$wrong=0;
$prev1=$prev2=$prev3=$prev4=$prev5=$prev6=$prev7=$prev8=$prev9="\n";
foreach $word (@words){

 if($word ne $testword){
  printWord;
 }else{
  getPrompt;
  testWord;
 }
 $pos++;
 if($pos>=$#words){exit;}
}

}
start();
